--
-- TargetsTarget.lua
--
TargetsTargetVersion = '1.0'

function TargetsTarget_OnEvent()
end

function TargetsTarget_OnUpdate(elapsed)
    -- Name
    local TT_FullName = "";
    
    local TT_Name = UnitName("targettarget");
    if (TT_Name==nil) then
        getglobal("TargetsTarget_Frame"):Hide();
        return;
    end
    
    local TT_Level = UnitLevel("targettarget");
    if (TT_Level == -1) then
        TT_FullName = "[??";
    else
        TT_FullName = "[" .. TT_Level;
    end
    
    if (UnitIsPlusMob("targettarget")) then
		TT_FullName = TT_FullName .. "+";
	end
	
	TT_FullName = TT_FullName .. "] " .. TT_Name;
	
	getglobal("TargetsTarget_FrameName"):SetText(TT_FullName);
	
	-- Reaction
	local TT_reaction = UnitReaction("player", "targettarget");
	if (TT_reaction == nil) then
		TT_reaction = 4;
	end
	
	-- Health
	local TT_healthPercent = 0;
	if (UnitHealthMax("targettarget") == 0) then
		TT_healthPercent = 0;
	else	
		TT_healthPercent = math.floor(UnitHealth("targettarget")*100/UnitHealthMax("targettarget"));
	end
	if (TT_healthPercent < 0) then
		TT_healthPercent = 0;
	end
	if (TT_healthPercent > 100) then
		TT_healthPercent =100;
	end
	
	-- Health Bar Color
	local TT_healthBarColor = TargetsTarget_GetHealthBarColor(TT_healthPercent);
	getglobal("TargetsTarget_FrameHealthBar"):SetStatusBarColor(TT_healthBarColor.r, TT_healthBarColor.g, TT_healthBarColor.b);										
	getglobal("TargetsTarget_FrameHealthBar"):SetValue(TT_healthPercent);

    -- Name Text Color
    if (TT_healthPercent <=0 ) then
        getglobal("TargetsTarget_FrameName"):SetTextColor(0.5, 0.5, 0.5);					
	else
		if (TT_reaction > 4) then
			getglobal("TargetsTarget_FrameName"):SetTextColor(0, 1, 0);					
		else
			if (TT_reaction == 4) then
				getglobal("TargetsTarget_FrameName"):SetTextColor(1, 1, 0);					
			else 
				if (TT_reaction > 0) then
					getglobal("TargetsTarget_FrameName"):SetTextColor(1, 0, 0);					
				else
					getglobal("TargetsTarget_FrameName"):SetTextColor(1, 1, 1);					
				end
			end
		end
	end

    -- Portrait Texture
    SetPortraitTexture(getglobal("TargetsTarget_FramePortrait"), "targettarget");
    
    -- PVP Flag
    local ispvp = UnitIsPVP("targettarget");
    if (ispvp == 1) then
        local englishFaction = UnitFactionGroup("targettarget");
        if (englishFaction == "Horde") then
            getglobal("TargetsTarget_FramePVPIcon"):SetTexture("Interface\TargetingFrame\UI-PVP-Horde");
        else
            getglobal("TargetsTarget_FramePVPIcon"):SetTexture("Interface\TargetingFrame\UI-PVP-Alliance");
        end
        getglobal("TargetsTarget_FramePVPIcon"):Show();
    else
        getglobal("TargetsTarget_FramePVPIcon"):Hide();
    end
    
    -- Party Leader Flag
    local isLeader = UnitIsPartyLeader("targettarget")
    if (isLeader == 1) then
        getglobal("TargetsTarget_FrameLeaderIcon"):Show();
    else
        getglobal("TargetsTarget_FrameLeaderIcon"):Hide();
    end
    
    -- Master Loot Flag
    getglobal("TargetsTarget_FrameMasterIcon"):Hide();

    -- Mana/Energy/Rage
    local mana = UnitMana("targettarget");
    local maxmana = UnitManaMax("targettarget");
    local manaPercent = mana / maxmana * 100;
    getglobal("TargetsTarget_FrameManaBar"):SetValue(manaPercent);
    
    local powerType = UnitPowerType("targettarget");
    if (powerType == 0) then
        -- Mana
        getglobal("TargetsTarget_FrameManaBar"):SetStatusBarColor(0, 0, 1);
    elseif (powerType == 1) then
        -- Rage
        getglobal("TargetsTarget_FrameManaBar"):SetStatusBarColor(1, 0, 0);
    elseif (powerType == 2) then
        -- Focus
        -- getglobal("TargetsTarget_FrameManaBar"):SetStatusBarColor(0.8, 0.2, 0.2);
    elseif (powerType == 3) then
        -- Energy
    elseif (powerType == 4) then
        -- Happiness
    end
    
    -- Show the Frame
    getglobal("TargetsTarget_Frame"):Show();
end

function TargetsTarget_GetHealthBarColor(healthPercent)
    -- 100-40 green (100) to yellow (40)
    -- 40-0 yellow to red
	
    local returnColor = { r = 0, g = 0, b = 0 };
	
    if (type(healthPercent) ~= "number") then
		return returnColor;
	end
	
	if (healthPercent >= 100) then
		returnColor.r = 0;
		returnColor.g = 1;
		returnColor.b = 0;
	elseif (healthPercent > 40) then
		returnColor.r = string.format("%4.2f", 1-((healthPercent-40)/60));
		returnColor.g = 1;
		returnColor.b = 0;
	elseif (healthPercent > 0) then
		returnColor.r = 1;
		returnColor.g = string.format("%4.2f", healthPercent/40);
		returnColor.b = 0;
	else
		returnColor.r = 0.5;
		returnColor.g = 0.5;
		returnColor.b = 0.5;
	end
	
	return returnColor;
end
